//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma link "Dxfconv"
#ifdef CADExportVCL
	#pragma link "Cadtodxf"
	#pragma link "Cadtodwg"
	#pragma link "Cadtohpgl"
	#pragma link "Cadtopdf"
	#pragma link "Cadtocgm"
	#pragma link "Cadtosvg"
#endif
#pragma link "Sgconsts"
#pragma
#pragma package(smart_init)
#pragma resource "*.dfm"


	const AnsiString cnstLayerName = "new_Layer";
	const AnsiString cnstSpline = "spline_Layer";
	const AnsiString cnstLTypeName = "new_LType";
	const AnsiString cnstStyleChinese = "SimSun_font_style";
	const AnsiString cnstLayoutTest = "Layout Test";

	const double cnstKnots[12] = {0,0,0,0, 9.36936792, 17.27242735, 26.43203326,
												34.54490857, 43.56494422, 43.56494422, 43.56494422,
												43.56494422};

	const TFPoint cnstControls[8] = {
		{193.7569940313442, 215.218107688496, 0.0},
		{190.008602213157, 216.4199761372127, 0.0},
		{183.0984428627155, 218.6356203125639, 0.0},
		{182.2793581329382, 203.2744864580255, 0.0},
		{195.7311751699836, 211.4104840390326, 0.0},
		{194.9308559557102, 195.9080522313814, 0.0},
		{188.1155501874722, 198.1118624085731, 0.0},
		{184.5274675101238, 199.2721116167301, 0.0}};


TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
bool __fastcall TForm1::NewDrawing(TObject *Sender)
{
	bool result = true;
	if (fDrawing)
		delete fDrawing;
	fDrawing = new TsgCADImage();
	try
	{
		fDrawing->Converter->InitializeSectionsBegin();
		fDrawing->Converter->InitializeSectionsEnd();
	}
	catch(...)
	{
		delete fDrawing;
		result = false;
	}
	return result;

}

void __fastcall TForm1::SetGraphic(TObject *Sender)
{
	sgPaintBox->Picture->Graphic = fDrawing;
	if (Form1->Width < int(fDrawing->AbsWidth()))
		Form1->Width = int(fDrawing->AbsWidth());
	if (Form1->Height < int(fDrawing->AbsHeight()))
		Form1->Height = int(fDrawing->AbsHeight());
	sgPaintBox->Invalidate();
}

bool __fastcall TForm1::PlaceEntity(TsgDXFEntity *AEntity, const AnsiString ALayoutName = "")
{
	bool result = false;
	TsgDXFLayout *vLayout;
	if (ALayoutName == "") {
		vLayout = fDrawing->Converter->Layouts[0];
	}
	else
		vLayout = fDrawing->Converter->LayoutByName(ALayoutName);
	if (vLayout)
	{
		fDrawing->Converter->Loads(AEntity);
		if (fDrawing->Converter->OnCreate)
			fDrawing->Converter->OnCreate(AEntity);
		vLayout->AddEntity(AEntity);
		result = true;
	}
	return result;
}

void __fastcall TForm1::Add2DVertex(TsgDXFLWPolyline *ALWPoly, const double X, const double Y, const double ABulge)
{
	TsgDXFVertex *vVertex = new TsgDXFVertex();
	vVertex->Point = MakeFPoint(X, Y, 0);
	vVertex->Bulge = ABulge;
	ALWPoly->AddEntity(vVertex);
}

void __fastcall TForm1::Add3DVertex(TsgDXFPolyline *APoly, const double X, const double Y, const double Z)
{
	TsgDXFVertex *vVertex = new TsgDXFVertex();
	vVertex->Point = MakeFPoint(X, Y, Z);
	APoly->AddEntity(vVertex);
}

void __fastcall TForm1::AddArc(TObject *Sender)
{
	TsgDXFArc * vArc = new TsgDXFArc();
	vArc->StartAngle = 60;
	vArc->EndAngle = 210;
	vArc->Radius = 50;
	vArc->Point = MakeFPoint(110, 160, 0);
	vArc->Color = clGreen;
	vArc->Layer = fDrawing->Converter->LayerByName(cnstLayerName);
	vArc->SetLType(fDrawing->Converter->LTypeByName(cnstLTypeName));
	if(!PlaceEntity(vArc))
		delete vArc;
}

void __fastcall TForm1::AddCircle(TObject *Sender)
{
	TsgDXFCircle * vCircle = new TsgDXFArc();

	vCircle->LineTypeScale = 0.2;
	vCircle->Radius = 30;
	vCircle->Point = MakeFPoint(110, 160, 0);
	vCircle->Color = clGreen;
	vCircle->Layer = fDrawing->Converter->LayerByName(cnstLayerName);
	vCircle->SetLType(fDrawing->Converter->LTypeByName(cnstLTypeName));
	if(!PlaceEntity(vCircle))
		delete vCircle;
}

void __fastcall TForm1::AddDimensionStyle(TObject *Sender)
{
	TsgDXFDimensionStyle *vDimStyle = new TsgDXFDimensionStyle();
	vDimStyle->ArrowSize = 10;
	vDimStyle->ArrowType = 3;
	vDimStyle->TextHeight = 12;
	vDimStyle->DIMDEC = 2;
	vDimStyle->TextPosVert = pvAbove;
	vDimStyle->Name = "TEST";
	vDimStyle->Scale = 1;
	AddEntToSection(fDrawing->Converter->Sections[csDimStyles], vDimStyle);
}

void __fastcall TForm1::AddDimension(TObject *Sender)
{
	TsgDXFDimension *vDimension = new TsgDXFDimension();
	vDimension->Flags = 1;
	vDimension->DefPoint = MakeFPoint(200,150,0);
	vDimension->LinDefPoint1 = MakeFPoint(20,88,0);
	vDimension->LinDefPoint2 = MakeFPoint(200,38,0);
	vDimension->TextOffset = 5;
	vDimension->TextOverride = "size";
	vDimension->Style = fDrawing->Converter->DimensionStyleByName("TEST");
	vDimension->Layer = fDrawing->Converter->LayerByName(cnstLayerName);
	if(!PlaceEntity(vDimension))
		delete vDimension;
}

void __fastcall TForm1::AddDisplayViewport(TObject *Sender)
{
	TsgDXFViewport *vViewport = new TsgDXFViewport();
	vViewport->PSpaceCenter = cnstFPointZero;
	vViewport->PSpaceWidth = 297;
	vViewport->PSpaceHeight = 210;
	vViewport->MSpaceCenter = vViewport->PSpaceCenter;
	vViewport->MSpaceHeight = vViewport->PSpaceHeight;
	vViewport->Flags = 32800;
	if (!PlaceEntity(vViewport, cnstLayoutTest))
		delete vViewport;
}


void __fastcall TForm1::AddEntToSection(TsgDXFGroup *Section, TsgDXFEntity *Entity)
{
	fDrawing->Converter->Loads(Entity);
	Section->AddEntity(Entity);
}

void __fastcall TForm1::AddFaceByVertices(TsgDXFPolyline *APoly, int N1, int N2, int N3, int N4)
{
	TsgDXFVertex *vVertex = new TsgDXFVertex();
	vVertex->PolyFaceVertexIndex1 = N1;
	vVertex->PolyFaceVertexIndex2 = N2;
	vVertex->PolyFaceVertexIndex3 = N3;
	vVertex->PolyFaceVertexIndex4 = N4;
	vVertex->Flags = 128;
	APoly->AddEntity(vVertex);
}

void __fastcall TForm1::AddHatch(TObject *Sender)
{
	TF2DPoint vPoint2D;

	TsgCADHatch *vHatch = new TsgCADHatch();
	Tsg2DBoundaryList *v2DBList = vHatch->AddBoundaryList(7);
	vHatch->HatchName = "ANSI31";
	vHatch->Color = clBlue;

	Tsg2DPolyline *v2DPolyline = new Tsg2DPolyline();
	v2DBList->Add(v2DPolyline);

	vPoint2D = MakeF2DPoint(200.0, 40.0);
	v2DPolyline->AddVertex(vPoint2D);

	vPoint2D = MakeF2DPoint(93.0,29.0);
	v2DPolyline->AddVertex(vPoint2D);

	vPoint2D = MakeF2DPoint(150.0, 120.0);
	v2DPolyline->AddVertex(vPoint2D);

	vPoint2D = MakeF2DPoint(200.0,40.0);
	v2DPolyline->AddVertex(vPoint2D);

	TsgHatchPatternData *vHPData = new TsgHatchPatternData();
	vHPData->BaseP = MakeFPoint(0, 0, 0);
	vHPData->Offset = MakeFPoint(-0.1, 0.1, 0);
	vHPData->LineAngle = 45.0;
	vHPData->IsDash = false;
	vHPData->DashNum = 0;

	vHatch->HatchPatternData->Add(vHPData);
	vHatch->Layer = fDrawing->Converter->LayerByName(cnstLayerName);

	if (!PlaceEntity(vHatch))
		delete vHatch;
}

void __fastcall TForm1::AddImageEnt(TObject *Sender)
{
	TsgDXFImageDef *vImageDef = new TsgDXFImageDef();
	vImageDef->FileName = "../Images/cadsofttools.bmp";
	fDrawing->Converter->Loads(vImageDef);
	if (vImageDef->Picture->Graphic)
	{
		fDrawing->Converter->Sections[csImageDefs]->AddEntity(vImageDef);
		TsgDXFImageEnt *vImageEnt = new TsgDXFImageEnt();
		vImageEnt->ImageDef = vImageDef;
		vImageEnt->Point = MakeFPoint(180, 100, 0);
		vImageEnt->UVector = cnstXOrtAxis;
		vImageEnt->VVector = cnstYOrtAxis;
		vImageEnt->Size = vImageEnt->ImageDef->Size;
		vImageEnt->Width = 59;
		if (!PlaceEntity(vImageEnt))
		{
			fDrawing->Converter->Sections[csImageDefs]->RemoveEntity(vImageDef);
			delete vImageDef;
			delete vImageEnt;
		}
	}
	else
  	delete vImageDef;
}

void __fastcall TForm1::AddInsert(TObject *Sender)
{
	TsgDXFInsert *vInsert = new TsgDXFInsert();
	TsgDXFBlock *vBlock = new TsgDXFBlock();
	vBlock->Name = "AttribsTest";
	vBlock->Flags = 2;

	TsgDXFAttdef *vAttdef = new TsgDXFAttdef();
	vAttdef->Tag = "ATTDEF#1";
	vAttdef->Text = "This is ATTDEF text";
	vAttdef->Height = 1;

	fDrawing->Converter->Loads(vAttdef);
	if (fDrawing->Converter->OnCreate)
		fDrawing->Converter->OnCreate(vAttdef);
	vBlock->AddEntity(vAttdef);

	fDrawing->Converter->Loads(vBlock);
	if (fDrawing->Converter->OnCreate)
		fDrawing->Converter->OnCreate(vBlock);
	fDrawing->Converter->Sections[csBlocks]->AddEntity(vBlock);

	vInsert->Block = vBlock;
	vInsert->Point = MakeFPoint(90, 90, 0);

	TsgDXFAttrib *vAttrib = new TsgDXFAttrib();
	vAttrib->Point = MakeFPoint(10, 10, 0);
	vAttrib->Tag = "ATTDEF#1";
	vAttrib->Value = "ATTRIB text!";
	vAttrib->Height = 20;

	fDrawing->Converter->Loads(vAttrib);
	if (fDrawing->Converter->OnCreate)
		fDrawing->Converter->OnCreate(vAttrib);
	vInsert->Attribs->Add(vAttrib);

	if(!PlaceEntity(vInsert))
		delete vInsert;
}

void __fastcall TForm1::AddLayer(TObject *Sender)
{
	TsgDXFLayer *vLayer = new TsgDXFLayer();
	vLayer->Name = cnstSpline;
	vLayer->Color = TColor(0x7F9FFF);
	AddEntToSection(fDrawing->Converter->Sections[csLayers], vLayer);
}

void __fastcall TForm1::AddLayout(TObject *Sender)
{
	TsgDXFLayout *vLayout = new TsgDXFLayout();
	vLayout->Name = cnstLayoutTest;
	AddEntToSection(fDrawing->Converter->Sections[csLayouts], vLayout);
}

void __fastcall TForm1::AddLine(TObject *Sender)
{
	TsgDXFLine *vLine = new TsgDXFLine();
	vLine->Point = MakeFPoint(80, 100, 0);
	vLine->Point1 = MakeFPoint(150, 150, 0);
	vLine->Color = clBlue;
	vLine->Layer = fDrawing->Converter->LayerByName(cnstLayerName);
	vLine->SetLType(fDrawing->Converter->LTypeByName(cnstLTypeName));
	vLine->LineWeight = 0.3;
	if (!PlaceEntity(vLine))
		delete vLine;
}

void __fastcall TForm1::AddLineType(TObject *Sender)
{
	TsgDXFLineType *vLineType = new TsgDXFLineType();
	vLineType->Name = cnstLTypeName;
	vLineType->Lines->AddTick(25);
	vLineType->Lines->AddTick(-12.5);
	AddEntToSection(fDrawing->Converter->Sections[csLTypes], vLineType);
}

void __fastcall TForm1::AddLWPolyline(TObject *Sender)
{
	TsgDXFLWPolyline *vLWPolyline = new TsgDXFLWPolyline();
	vLWPolyline->Closed = true;
	vLWPolyline->GlobalWidth = 4;
	Add2DVertex(vLWPolyline, -50, -50, 0.2);
	Add2DVertex(vLWPolyline, -50, 350, 0.2);
	Add2DVertex(vLWPolyline, 300, 350, 0.2);
	Add2DVertex(vLWPolyline, 300, -50, 0.2);
	vLWPolyline->Color = clNavy;
	vLWPolyline->SetLType(fDrawing->Converter->LTypeByName(cnstLTypeName));
	vLWPolyline->Layer = fDrawing->Converter->LayerByName(cnstLayerName);
	if(!PlaceEntity(vLWPolyline))
		delete vLWPolyline;
}

void __fastcall TForm1::AddModelViewport(TObject *sender)
{
	TsgDXFViewport *vViewPort = fDrawing->Converter->GenerateModelViewPort(cnstFPointZero, 297, 210, false);
	vViewPort->MSpaceHeight = 170;
	if(!PlaceEntity(vViewPort, cnstLayoutTest))
		delete vViewPort;
}

void __fastcall TForm1::AddMText(TObject *Sender)
{
	TsgDXFMText *vMText = new TsgDXFMText();
	vMText->Text = "MText (center)";
	vMText->Point = MakeFPoint(125, 250, 0);
	vMText->RectWidth = 250;
	vMText->Align = 5;
	vMText->Height = 15;
	vMText->Color = clTeal;
	vMText->Layer = fDrawing->Converter->LayerByName(cnstLayerName);
	if(!PlaceEntity(vMText))
		delete vMText;
}

void __fastcall TForm1::AddPolyline1(TObject *Sender)
{
	TsgDXFPolyline *vPolyline = new TsgDXFPolyline();
	vPolyline->Closed = true;
	vPolyline->LineWeight = 0.01 * sgDXFLineWeights[sizeof(sgDXFLineWeights)/sizeof(int) - 1];
	Add3DVertex(vPolyline, 0, 0, 0);
	Add3DVertex(vPolyline, 0, 300, 0);
	Add3DVertex(vPolyline, 250, 300, 0);
	Add3DVertex(vPolyline, 250, 0, 0);
	vPolyline->Color = clMaroon;
	vPolyline->Layer = fDrawing->Converter->LayerByName(cnstLayerName);
	if(!PlaceEntity(vPolyline))
		delete vPolyline;
}

void __fastcall TForm1::AddPolyline2(TObject *Sender)
{
	TsgDXFPolyline *vPolyline = new TsgDXFPolyline();
	vPolyline->Flags = 64;
	vPolyline->MeshM = 10;
	vPolyline->MeshN = 3;

	Add3DVertex(vPolyline, 157, 177, 0);
	Add3DVertex(vPolyline, 190, 196, 0);
	Add3DVertex(vPolyline, 223, 176, 0);
	Add3DVertex(vPolyline, 209, 203, 0);
	Add3DVertex(vPolyline, 234, 218, 0);
	Add3DVertex(vPolyline, 201, 218, 0);
	Add3DVertex(vPolyline, 190, 244, 0);
	Add3DVertex(vPolyline, 179, 219, 0);
	Add3DVertex(vPolyline, 148, 219, 0);
	Add3DVertex(vPolyline, 172, 204, 0);

	AddFaceByVertices(vPolyline, 1, 5, 8, 0);
	AddFaceByVertices(vPolyline, 3, 7, 10, 0);
	AddFaceByVertices(vPolyline, 9, 8, 10, 0);
	vPolyline->Color = clRed;
	vPolyline->Layer = fDrawing->Converter->LayerByName(cnstLayerName);
	if(!PlaceEntity(vPolyline))
		delete vPolyline;
}

void __fastcall TForm1::AddSolid(TObject *Sender)
{
	TsgDXFSolid *vSolid = new TsgDXFSolid();
	vSolid->Point = MakeFPoint(20, 50, 0);
	vSolid->Point1 = MakeFPoint(80, 50, 0);
	vSolid->Point2 = MakeFPoint(80, 90, 0);
	vSolid->Point3 = MakeFPoint(20, 90, 0);
	vSolid->Color = clNavy;
	vSolid->Layer = fDrawing->Converter->LayerByName(cnstLayerName);
	if(!PlaceEntity(vSolid))
		delete vSolid;
}

void __fastcall TForm1::AddSpline(TObject *Sender)
{

	TsgDXFSpline *vSpline = new TsgDXFSpline();
	for (int I = 0; I < sizeof(cnstControls)/sizeof(double)/3; I++)
	{
		TFPoint vPPoint3D = cnstControls[I];
		vSpline->Controls->Add(vPPoint3D);
	}
	for (int I = 0; I < sizeof(cnstKnots)/sizeof(double); I++)
		vSpline->Knots->Add(cnstKnots[I]);
	vSpline->Layer = fDrawing->Converter->LayerByName(cnstSpline);
	if(!PlaceEntity(vSpline))
		delete vSpline;
}

void __fastcall TForm1::AddStyle(TObject *Sender)
{
	TsgDXFStyle *vStyle = new TsgDXFStyle();
	vStyle->Name = cnstStyleChinese;
	vStyle->PrimaryFont = "SimSun";
	AddEntToSection(fDrawing->Converter->Sections[csStyles], vStyle);
}

void __fastcall TForm1::AddText1(TObject *Sender)
{
	TsgDXFText *vText = new TsgDXFText();
	vText->Text = "Text";
	vText->Point = MakeFPoint(10, 280, 0);
	vText->Height = 10;
	vText->Color = clTeal;
	vText->Layer = fDrawing->Converter->LayerByName(cnstLayerName);
	if(!PlaceEntity(vText))
		delete vText;
}

void __fastcall TForm1::AddText2(TObject *Sender)
{
	TsgDXFText *vText = new TsgDXFText();
	vText->Text = "Unicode+Chinese: \\U+00B11\\U+00B0\\U+7777";
	vText->Style = fDrawing->Converter->StyleByName(cnstStyleChinese);
	vText->Point = MakeFPoint(10, 265, 0);
	vText->Height = 10;
	vText->Color = clTeal;
	vText->Layer = fDrawing->Converter->LayerByName(cnstLayerName);
	if(!PlaceEntity(vText))
		delete vText;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btPicture1Click(TObject *Sender)
{
	if (!NewDrawing(this))
		return;
	AddLineType(this);
	AddPolyline1(this);
	AddLWPolyline(this);
	AddInsert(this);
	fDrawing->GetExtents();
	SetGraphic(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btPicture2Click(TObject *Sender)
{
	if (!NewDrawing(this))
		return;
	AddPolyline1(this);
	AddStyle(this);
	AddText1(this);
	AddText2(this);
	AddMText(this);
	fDrawing->GetExtents();
	SetGraphic(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btPicture3Click(TObject *Sender)
{
	if (!NewDrawing(this))
		return;
	AddLineType(this);
	AddLine(this);
	AddLWPolyline(this);
	AddArc(this);
	AddCircle(this);
	fDrawing->GetExtents();
	SetGraphic(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btPicture4Click(TObject *Sender)
{
	if (!NewDrawing(this))
		return;
	AddLayer(this);
	AddPolyline1(this);
	AddPolyline2(this);
	AddSpline(this);
	AddSolid(this);
	AddDimensionStyle(this);
	AddDimension(this);
	AddHatch(this);
	fDrawing->GetExtents();
	SetGraphic(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btFullPictureClick(TObject *Sender)
{
	if (!NewDrawing(this))
		return;
	AddLayer(this);
	AddLineType(this);
	AddStyle(this);
	AddArc(this);
	AddCircle(this);
	AddDimensionStyle(this);
	AddDimension(this);
	AddHatch(this);
	AddImageEnt(this);
	AddInsert(this);
	AddLine(this);
	AddLWPolyline(this);
	AddMText(this);
	AddPolyline1(this);
	AddPolyline2(this);
	AddSolid(this);
	AddSpline(this);
	AddText1(this);
	AddText2(this);
	fDrawing->GetExtents();
	AddLayout(this);
	AddDisplayViewport(this);
	AddModelViewport(this);
	SetGraphic(this);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btSaveClick(TObject *Sender)
{
	if (!fDrawing)
	{
		MessageBox(Application->Handle, "A drawing not created, press another button.", "Warning", MB_OK || MB_ICONWARNING);
		return;
	}
#ifdef CADExportVCL
	SaveDialog->FileName = "Test";
	SaveDialog->FilterIndex = 1;
	if (!SaveDialog->Execute() || SaveDialog->FileName == "")
		return;
	switch (SaveDialog->FilterIndex) {
			case 1:
			{
				TsgCADtoDXF *vDXF = new TsgCADtoDXF(fDrawing);
				vDXF->SaveToFile(SaveDialog->FileName);
				delete vDXF;
				break;
			}
			case 2:
			{
				TsgCADtoDWG *vDWG = new TsgCADtoDWG(fDrawing);
				vDWG->SaveToFile(SaveDialog->FileName);
				delete vDWG;
				break;
			}
			case 3:
			{
				TsgHPGLExport *vPLT = new TsgHPGLExport(fDrawing);
				vPLT->SaveToFile(SaveDialog->FileName);
				delete vPLT;
				break;
			}
			case 4:
			{
				TsgPDFExport *vPDF = new TsgPDFExport(fDrawing);
				vPDF->SaveToFile(SaveDialog->FileName);
				delete vPDF;
				break;
			}
			case 5:
			{
				TsgCADtoCGM *vCGM = new TsgCADtoCGM(fDrawing);
				vCGM->SaveToFile(SaveDialog->FileName);
				delete vCGM;
				break;
			}
			case 6:
			{
				TsgCADtoSVG *vSVG = new TsgCADtoSVG(fDrawing);
				vSVG->SaveToFile(SaveDialog->FileName);
				delete vSVG;
				break;
			}
			default:
			{
				break;
			}
	}
#else
	ShowMessage("CAD Export VCL required to export into CAD formats");
#endif
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  SaveDialog->Filter = "*.dxf|*.dxf|*.dwg|*.dwg|*.plt|*.plt|*.pdf|*.pdf|*.cgm|*.cgm|*.svg|*.svg";
}
//---------------------------------------------------------------------------

